# fab-arcade-menu

The fab-arcade is being run on python 3.10.8

## Getting started
Follow the steps below to start working on the project: 

1. For the project we will be using python 3.10. Since that is the latest supported python version for pygame. Link to the [begineers guide](https://wiki.python.org/moin/BeginnersGuide/Download) and python [download page](https://www.python.org/downloads/)

2. Start vscode and press `command + shift + p` to bring up the command pallete in it search for the `python:create Environment` option and press it. Link to the vscode documentation [here](https://code.visualstudio.com/docs/python/environments#:~:text=From%20within%20VS%20Code%2C%20you,environment%20types%3A%20Venv%20or%20Conda)

3. After this select Venv as the environment type. 

4. If you have several python versions select python 3.10

5. This will setup the virtual environment in the current workspace for you.

6. To check that everything is setup correctly, pull up the integrated terminal in vscode and besides the terminal line a (.venv) should show up at the start of every new line on the terminal. This will tell you that the virtual environment is up and running properly in vscode. After that, run the following commands. 

```bash
    python --version 
    # Should return Python 3.10.8
    python3 --version
    # Should return Python 3.10.8
    # If it doesnt then there is a problem and just give me a call
```

7. To install the required dependencies to run the project go to the root folder with the *requirements.txt* file and type in the following command in the integrated vscode terminal. This will install all the requisite packages for the project to run. 
    
```bash
    python -m pip install -r requirements.txt 
```

8. Make sure that there is a games folder ("games") in your directory. For more information on the folder sturcture, please reference Section 3 Folder Structure in fab-arcade-menu-spec.md. You can find it [here](https://git.rwth-aachen.de/mcp-fab-arcade/mcp-group-2-integration/fab-arcade-menu/-/blob/main/docs/fab-arcade-menu-spec.md#3-folder-structure). For testing purposes, we have included some Mock Manifests into the games folder.

9. Run src/main.py . It should start the fab arcade menu

```bash
    python src/main.py
```


## Using the python virtual environment
We will use the python virtual environment to make sure that all the dependencies for the project are self contained and can be replicated.
Whenever we want to use pip install to install modules we will have to first activate the virtual environment (venv).

If you follow the setup instructions and have created a seperate workspace for this project in vscode it should automatically pick the virtual environment up.
For running the code please use the integrated python terminal as it already starts the virtual environment.

This would also resolve the issue of using python and python3 as within the virtual environment both will point to the currently set up version of python

## Typing and import assistance in VSCode
Make sure to select the python 3.10 interpreter in the command palette using the python select interpreter command. This is to make sure the imports and dependencies are correctly resolved and it does not lead to an unable to resolve import error.


# Project Features

2 Parts to the Menu:
- Carousel 
- Grid

1. We need to look into the pygame menu documentation

Carousel
2. Writing from Scratch. Abstracting Class.
    - Carousel Controls
    - Indicators
    - Events 
3. How to get Images in.
4. Basic Animation for carousel interaction.
5. Animating Image .

Grid
2. Writing from Scratch. Abstracting Class.
    - Grid Controls
    - Fixed Grid 
    - Events 
3. How to get Images in.
4. Basic Animation for carousel interaction.

Overarching UI Controls and Display.
1. Icons and Text to show what are the control options available based on the current menu type.
2. As boring as possible.

Loading Screens 
1. Loading Screen for launching game.

Error Screens 
1. Figure out the error states. 

Specifications for the file structure and JSON schema for the manifest. (Shailesh)
This has a direct impact on How games are uploaded.
How to upload the games themselves. 

Figure out the general process of working with the Pi. (Shailesh)
1. Set up the pi privileges and everything else as mentioned in the documentation.  
2. We need to make sure that Menu launches at startup.
3. Docker setup. 

Splash Screen for the menu.

License


# Resource References

- Public Pixel Font - https://opengameart.org/content/public-pixel-font
- Tom Peter (back34)- https://opengameart.org/content/8bit-style-music
- JRPG Style UI Sounds (KillaMaaki) - https://opengameart.org/content/jrpg-style-ui-sounds
