---
title: Fab Arcade Menu Specification
version: 0.0.4
author: Shailesh Iyer, Sijia Guo
lastUpdated: 25-01-2023
---

# Fab Arcade Menu Functional Specifications
## 1. Overview
This is the fucntional specifications of the FabArcade menu. It discusses the users interactions with the FabArcade menu and what they see as well as certain details about the file structure imposed on the games and how to upload them as well.

This spec is not by any stretch complete and I will keep working on it until the end of the Final of the Presentation.

## 2. Fab Arcade Control Layout 
Before we can start discussing the menu in the earnest, we need to take a look at the controls.
The fab arcade has the following controls:
- Home button: This will return the user back to the menu any time it is pressed from within the game. It will also return the user back to the carousel menu anytime it is pressed while in the menu.
- JoyStick Controls: The FabArcade has 2 joystick controls. From here on out the left joystick will be referred to as 'joystick 1' and the right joystick as 'joystick 2'. This will be used for movement in the menu. **For most intents and purposes the joysticks will be mirrored when in the FabArcade menu.** 

- Player Icon/Start Button: The Fab Arcade has a single and multiplayer start button besides joystick 1 and 2 . These can be used to start the games.

- Coin Slot: The coin slot is used to indicate where the user can insert coins into the fab arcade. There is an arrow to indicate where this slot exists.


- Colored Buttons: The FabArcade has 8 buttons. There are 2 sets of these.  1 set of 4 buttons for each joystick. Going  from top left in clockwise direction they are respectively colored as Blue, Yellow, Red and Black. 
From here on they may also be referred to as Blue 1, Yellow 1, Red 1 and Black 1 for joystick 1. Similarly they may be referred to as Blue 2, Yellow 2, Red 2 and Black 2 for joystick 2. **In case I am only referring to the color of the button and not the number it can be assumed that the controls are mimicked on both buttons for that action.**

## 3. Folder Structure
The folder structure will be mostly similar and borrowed from the previous fab arcade documentation.
### 3.1 File Structure of the home folder on the Raspberry PI

```bash
# Structure of the arcades home folder
/home/arcade/
            fab-arcade-menu/  # The Codebase for the menu itself
            games/            # The games created by groups will be stored here
        
```

Delving a little deeper into the the structure of the games folders:
### 3.2 File Structure of the Games Folder
The games folder will have the following structure where there will be further subfolders where each of the games created by the groups will be stored. At the root of every game folder, there is an assumption that a manifest.json file will be present which gives us the required metadata for the game and how to start it. We will take a look at the manifest in the [next section](#33-manifest-file) 
```bash
/games/                     # Games Folder
    game 1/                 # Games Sub Folder
        ...                 # Game Files and Code
        manifest.json       # Manifest File
    game 2/
    game 3
    ...
```

### 3.3 Manifest File
 The manifest file tells us all the metadata required to run, display and launch the game successfully from the menu. The JSON file containing the metadata of the game should be named as 'manifest.json', all in lowercase. The manifest file needs to be present at the root folder of the project. It has the following configuration.
 

**WARNING**

If the JSON manifest file is missing the game is assumed to not exist and will not be shown in the fab arcade menu.

```js
{
    /**
     * The command to run in the terminal to start the game.
     * This is important.
    */
    start: 'String' ,
    /**
     * The name of the game. This is the name displayed in the menus.
     * Please make sure this is short max 20 character
    */
    name: 'String',
    // The current version number of the game
    version: 'String',
    // Year the game was created
    year:'String',
    // Relative string path for the display image of the game in the carousel
    coverArt: 'String',
    // Relative string path for the image of the game for the grid
    image: 'String',
    // Tells if the game is multiplayer or not.
    isMultiplayer: Boolean,
    // Tells if the game is legacy. Converts joystick to keyboard input
    isLegacy: Boolean,
    // Description for the Game max(200 characters)
    description: 'String',
    // Command to install the game properly
    install: 'String',
    // Commands to run before running install
    preinstall: 'String',
    // Names of the group members
    groupMembers: [
        'String',
        'String',
        ...
    ]
}
```


## 4. Overarching UI Controls and Display Specifications.
This section is mainly to talk about how the overarching menu would look like and other contraints.

The display resolution for the fab arcade is assumed to be a 1280x720. 

This is the overarching layout for the Main Menu UI: There is a large content area in the middle and at the bottom there is a small bar. 

The content area can be either the carousel or the grid. This is mostly used to display and interact with the games on the arcade. 

On the bottom bar, the currently usable controls will be displayed. These will tell the user what actions are possible and how to do certain things. 

Controls:
- The Yellow button is fixed in the Main Menu to allow for switching the layout of the menu. This is primarily assumed to be Yellow 1. It can also be Yellow 2.
- The Start button will be used to Select or Start the game. 
- The Joystick is primarly used to move around the options presented in the menu in the arcade. This is primarily assumed to be Joystick 1. It can also be Joystick 2.

## 5. Animations and Transitions
Animations and transitions are important for giving feedback to the user to make sure that the user understands that an action has been completed or that input has been recieved. Of these, the most important are the screen transitions to make sure that the user feels that the screens are smoothly transitioning from one screen to the next. 

## 6. Screens and Components
This section is dedicated to discussing all the screens that appear in the fab arcade menu.

### 6.1 Bootup Screen
The bootup screen will be first screen that is shown when the FabArcade menu boots up.

This screen serves as something to display to the user while the FabArcade initialises things and makes sure to run some integrity/validation tests while the it boots up.

This the transitions to the splash screen.

### 6.2 Splash Screen
The splash screen will show a splash art, important logos and a QR code that leads to the FabArcade website. 

The splash art should have some sort of a loading animation like a circle or a progress bar. So that the user understands that some progress is happening on the fab arcade and that it is not just stuck. 

This then transitions to the main screen with a huge content area in the middle and a persistent bottom bar that shows available controls and options.

### 6.3 Main Screen - Carousel Screen
The carousel screen looks like a Netflix carousel screen with a huge image of the current item/ game in the middle. It also shows slight parts on the left and right of the previous and next item/game. The Carousel also wraps around meaning that if you reach the last index it will show the first child as the next item on the carousel.

The Game Image have a border along it to showcase that it is selected. 

The name of the game should be displayed as text below the carousel.

The only movement options available are to go either left or right with the joysticks.
The yellow button is used to switch the layout of the menu.

The carousel will be implemented as a class. The following are some of the methods it needs to implement. 
- init(Array): Initialises the carousel and will implement the required things for the carousel to function. It accepts an array of structures as an input to initalise. Each child item will have the following structure.
```
{
    id: Number,
    image: 'String',
    altText: 'String',
    text: 'String'
    onSelect: Function,
}
```
- render(): Draws the carousel once every frame. This is used to animate and interact with the UI and implement graphics
- next(): Implements the method to go to the next item in the carousel.
- previous(): Implements the method to go the previous item in the carousel.
- goTo(Integer): implements a method to go directly to a particular index on the carousel.

Events 
- OnSelect - fires when an item on the carousel is selected.
- OnChange - fires when the slide is about to transition
- OnChanged - fires after the slide has finished transitioning.

### 6.4 Grid Menu Layout Screen
This is accessed by pressing the Yellow button on the Main Screen. In the grid layout the Games are positioned in a 4x3 grid with 12 items in total per page. 
The games are being displayed as squares with their images and text below them with the name of the game. On the right side of the grid, the description of each game is displayed.

The Joystick can be used to move in all directions. The start button is used to launch the games and the yellow button is used to change the layout.

The currently selected game item has a highlighted border along the entire image. 

There should also be a page indicator at the bottom right of the screen above the bottom bar.

The page is only changed on reaching the right side or left side.

The Grid will be implemented as a class. It will have the following methods:
- init(Array): to initialise the grid with all the games and everything else. 
it will accept an array of Structs similar to the carousel.
Each child item will have the following structure.
    ```
    {
        id: Number,
        image: 'String',
        altText: 'String',
        text: 'String'
        onSelect: Function,
    }
    ```
- render() - Draws the grid on every frame. Is responsible for all the animation and drawing tasks.
- move(direction, index) - implements the movement on the grid for the joystick and changes what the active item is on the grid. 
- changePage(pageNumber) - Changes the current page on the grid.
- onSelect() - On Item select.

Events 
- onMove - Fires when the movement animation is about to start.
- onMoved - Fires after the movement animation is complete.
- onPageChange - Fires on page change
- onPageChanged - Fires after the page change is complete
- onItemSelect - Fires when an item is selected. 

### 6.5 Persistent Bottom Bar
The persistent bottom bar is always present in the bottom in all the menu layouts to show the user what actions are possible and what button does what. 
It is basically a string of icons and text with the icons showing what actions are possible in a given menu layout . 
The most common actions would be the joystick for showing which movement directions are possible. 
The start button to start the game.
The home button to return back to the main menu.
The yellow button to switch the layout of the menu.
The red button brings the user to the credits screen.

### 6.6 Game Loading Screen

This screen has an loading animation or progress bar. This will be usually shown whenever a game is about to boot up on the system. It will have the text **'Loading'**.
The Loading screen needs to have some animation to help the user understand that it is not stuck while this is used as a cover to initalise and launch the game.

### 6.7 Error Screen
This is shown when there is an error that the menu cannot really recover from. It just tells the user to contact the developers or the faculty since something has gone wrong. 

### 6.8 Credit Screen
The Creditscreen scrolls by itself and includes all the information on the MCP Lab from WiSe 22/23. You can also control the speed.

## 7. Figma Mockup
The Figma Mockup of the menu can be found here: https://www.figma.com/file/bB5joeHCgYqgCtDn9UMbts/mcp_menu?node-id=0%3A1&t=eVKd73qtgUZmCMsQ-1




