import pygame
from Constants import *

class BootImg(pygame.sprite.Sprite):
    def __init__(self, pos_x, pos_y):
        super().__init__()
        
        img1 = pygame.transform.smoothscale(pygame.image.load("./assets/bootscreen/boot1.png").convert(),(SCREEN_WIDTH,SCREEN_HEIGHT))
        img2 = pygame.transform.smoothscale(pygame.image.load("./assets/bootscreen/boot2.png").convert(),(SCREEN_WIDTH,SCREEN_HEIGHT))
        img3 = pygame.transform.smoothscale(pygame.image.load("./assets/bootscreen/boot3.png").convert(),(SCREEN_WIDTH,SCREEN_HEIGHT))
        img4 = pygame.transform.smoothscale(pygame.image.load("./assets/bootscreen/boot4.png").convert(),(SCREEN_WIDTH,SCREEN_HEIGHT))
        
        
        self.sprites = []
        self.sprites.append(img1)
        self.sprites.append(img2)
        self.sprites.append(img3)
        self.sprites.append(img4)
        self.current_sprite = 0
        self.image = self.sprites[self.current_sprite]

        self.rect = self.image.get_rect()
        self.rect.topleft = [pos_x,pos_y]

        self.framecount = 0   
        

    def update(self):
        self.framecount += 1
        
        if self.framecount % 30 != 0:
           return 
        
        self.current_sprite += 1
        
        if self.current_sprite >= len(self.sprites):
            self.current_sprite = 0
        
        self.image = self.sprites[self.current_sprite]