import pygame
from pygame.surface import Surface

from Colors import DARK_GRAY,WHITE,BLACK

class CarouselIndicatorItem:
    def __init__(self,screen: Surface) -> None:
        self.screen = screen
        self._surface = Surface((33,8))
        self._rect = pygame.draw.rect(self._surface,DARK_GRAY,(0,0,33,8),33,100)
        

    @property
    def surface(self):
        return self._surface
    
    @property
    def rect(self):
        return self._rect
    
    @surface.setter
    def surface(self,s):
        self._surface = s

    @rect.setter
    def rect(self,r):
        self._rect = r
    
    def activate(self):
        # self._surface.blit(self._surface,self._rect,self._rect)
        self._surface.fill(BLACK)
        self._rect = pygame.draw.rect(self._surface,WHITE,(0,0,33,8),33,100)
        self._surface.blit(self._surface,self._rect)
 
    def deactivate(self):
        # self._surface.blit(self._surface,self._rect,self._rect)
        self._surface.fill(BLACK)
        self._rect = pygame.draw.rect(self._surface,DARK_GRAY,(0,0,33,8),33,100)
        self._surface.blit(self._surface,self._rect)
        