import pygame
import ftfy

from Colors import BLACK
from Constants import *

class Credits():
    """ The Credit Screen
        Its contents are read from the credits.txt file. 
        As such, any changes to the credits can be easily changed in the .txt file.
    """
    def __init__(self, screen, font, mainClock, speed):
        
        fileLines = open('assets/credits/credits.txt').readlines()
        credit_list = []
        for index in range(0, fileLines.__len__()-1):
            credit_list.append(ftfy.fix_text(fileLines[index].replace("\n","")))

        self.screen = screen
        self.screen_r = screen.get_rect()
        self.font = pygame.font.Font(FONT_FILE_PATH, 20)
        self.mainClock = mainClock
        self.speed = speed
        self.texts = []
        for i, line in enumerate(credit_list):
            s = self.font.render(line, True, (255, 255, 255))
            r = s.get_rect(centerx = self.screen_r.centerx, y = self.screen_r.bottom + i * 45)
            self.texts.append((r,s))
        

    def render(self):

        # Text scrolls up
        for r, s in self.texts:
            r.move_ip(0, -self.speed)
            self.screen.blit(s, r)
            
        # At the end of the credits display the logo       
        if not self.screen_r.collidelistall([r for (r,_) in self.texts]):
            self.screen.fill((0,0,0))
            logo = pygame.transform.smoothscale(pygame.image.load("./assets/splashscreen/pixel_logo.png").convert(),(SCREEN_WIDTH/2,SCREEN_HEIGHT/3))
            self.screen.blit(logo, (SCREEN_WIDTH/2-logo.get_width()/2, SCREEN_HEIGHT/2-logo.get_height()/2))
          #  pygame.quit()

    def accelerate(self):
        self.speed = self.speed+1

    def slowDown(self):
        self.speed = self.speed-1
