from Constants import ENABLE_HOME_BUTTON,HOME_BUTTON_DOWN,HOME_BUTTON_UP
from pygame.event import Event,post
from time import sleep
# import RPi.GPIO as GPIO

from gpiozero import Button, Device

# Mock pins for testing without the pi
if not ENABLE_HOME_BUTTON:
    from gpiozero.pins.mock import MockFactory    
    Device.pin_factory = MockFactory()

class HomeButton():
    """ The input of the home button is read directly from the pins of the pi
    """
    def __init__(self) -> None:
        PIN_HOME_BUTTON = 17

        # Initialise button
        self.button = Button(PIN_HOME_BUTTON)

        self.button.when_pressed = self.home_down
        self.button.when_released = self.home_up
        print('Home Button initialized...')
    

    def home_down(self):
        # Post custom home button down event to the event queue
        post(Event(HOME_BUTTON_DOWN,{'name':'HOME_BUTTON_DOWN','key':'HOME_BUTTON'}))
    

    def home_up(self):
        # Post custom home button up event to the event queue
        post(Event(HOME_BUTTON_UP,{'name':'HOME_BUTTON_UP', 'key':'HOME_BUTTON'}))


    def test(self):
        print('home value',self.button.value)
        sleep(10)

        print('home value',self.button.value)
        self.button.pin.drive_low()
        print('home value',self.button.value)
        sleep(0.4)
        self.button.pin.drive_high()
        print('home value',self.button.value)
        sleep(15)
        print('home value',self.button.value)
        self.button.pin.drive_low()
        print('home value',self.button.value)
        sleep(0.4)
        self.button.pin.drive_high()



    

    
