"""
This view is not really being used in the Menu Aymore so yea Just let it remain since.
We have references to it.
Created by MCP Group 2 
Authors: Shailesh Iyer, Sijia Guo,Lina Gönnheimer,Katharina Güths
=========== DISCLAIMER ==============================================================
Provided as is. May contain bugs with your game so make sure to test on the fabarcade.
Also you may have to do input debouncing for chorded input.  
I have tested the latest version on the pi and the fabarcade.It works decently well.
=====================================================================================
"""

from typing import List as TList

import pygame
from button import button
from pygame.surface import Surface
from pygame.rect import Rect

import Colors
from Constants import *
from Controls import Controls
from Manifest import Manifest

class List():

    def __init__(self, screen:Surface, originX, originY,width,height, manifestList):
        self.manifestList = manifestList
        self.size = len(manifestList)
        self.screen = screen
        self.surface = Surface((width,height))
        self.x = originX
        self.y = originY
        self.width = width
        self.height = height

        self.numButtonsOnScreen = min(self.size, 6)
        # self.numButtonsOnScreen = 4
        # self.font = pygame.font.Font(FONT_FILE_PATH, 18)
        # self.fontList = pygame.font.Font(FONT_FILE_PATH, 25)
        # self.fontTitle = pygame.font.Font(FONT_FILE_PATH, 20)
        self.font = pygame.font.Font(FONT_FILE_PATH, 10)
        self.fontList = pygame.font.Font(FONT_FILE_PATH, 14)
        self.fontTitle = pygame.font.Font(FONT_FILE_PATH, 12)

        self.isAnimating = False
        self.count = 0
        self.newPos = [0,0]
        self.total_animation_frames = 10
        self.debounce_count = 0
        self.total_debounce_frames = 8

        self.buttonList: TList[button] = []
        self.numRecList: TList[Rect] = []
        self.numSurfaceList: TList[Surface] = []
        
        self.cover = Surface((1280, 45))
        self.cover.fill(Colors.BLACK)

        self.slice_x= width/12
        self.slice_y = height/12

        for x,manifest in enumerate(manifestList):

            # item = button(418,35,manifest.name, Colors.BLACK)
            # item.rect = item.rect.move((310,(50*x)+50))

            item = button(4*self.slice_x,35,manifest.name, Colors.BLACK)
            item.rect = item.rect.move((self.slice_x*3,(50*x)+50))

            self.buttonList.append(item)


            
            # num = pygame.draw.rect(numSurface, Colors.BLACK, (190, 50+ (50*x),60,35))
            number = self.fontList.render((str(x+1)+'.'), True, Colors.WHITE)
            # numSurface = Surface((60,35))
            numSurface = Surface((40, item.rect.height))
            numSurface.fill(Colors.BLACK)
            numSurface.blit(number, ((numSurface.get_width()/2 - number.get_width()/2),(numSurface.get_height()/2 - number.get_height()/2)))
            self.numSurfaceList.append(numSurface)
            num = pygame.rect.Rect(0, 0,number.get_width(),self.slice_y*0.5)
            num.right = item.rect.left - 40
            num.y = item.rect.y
            self.numRecList.append(num)

        self.cursorPos = 0
        self.cursorSurface = Surface((self.buttonList[0].rect.width * 1.2 ,50))
        self.cursorSurface.fill(Colors.BLACK)
        self.cursorRect = pygame.rect.Rect(0,0, self.buttonList[0].rect.width * 1.2 ,50)
        self.cursor = pygame.draw.rect(self.cursorSurface, Colors.WHITE, self.cursorRect, width=5)
        self.cursorRect.center = self.buttonList[0].rect.center

        border = 10
        border_y = 5
        self.infoSurface = Surface((self.slice_y*6.3,6*50))
        self.infoSurfaceRect = pygame.rect.Rect(self.slice_x*7.5,self.slice_y*2,self.slice_y*6.3,self.slice_x * 4)
        self.infoSurfaceRect.y = self.cursorRect.y
        # self.infoSurface.get_rect() = pygame.draw.rect(self.infoSurface, Colors.GRAY, (self.slice_x*7.5,self.slice_y*2,self.slice_y*6.3,self.slice_x * 4.3))
        self.titleRect = pygame.rect.Rect(0,border_y, self.infoSurface.get_rect().width - 2*border,20)
        self.titleRect.centerx = self.infoSurface.get_rect().centerx
        self.title = pygame.draw.rect(self.infoSurface, Colors.GRAY, self.titleRect)
        
        self.infoRect = pygame.rect.Rect(0, self.title.bottom + border_y, self.infoSurface.get_rect().width - 2*border,self.infoSurface.get_rect().height - self.title.height - 2*border_y)
        self.infoRect.centerx = self.infoSurface.get_rect().centerx
        self.info = pygame.draw.rect(self.infoSurface, Colors.GRAY, self.infoRect)
        
        # self.info.y = self.title.bottom + border_y
        default_height = self.infoSurface.get_rect().height
        scrollBarHeight = round(default_height/self.size/self.total_animation_frames) * self.size * self.total_animation_frames
        
        self.scrollBarSurface = Surface((10, scrollBarHeight))
        self.scrollBar = pygame.draw.rect(self.scrollBarSurface, Colors.GRAY, (0,0,10, scrollBarHeight), 0,3)
        self.scrollBarRect = pygame.rect.Rect(self.infoSurfaceRect.right + border,self.infoSurfaceRect.y,10, scrollBarHeight)



        self.sliderSurface = Surface((10,(self.scrollBar.height/self.size)*self.numButtonsOnScreen))
        self.sliderRect = pygame.rect.Rect(0,0,10, ((self.scrollBar.height/self.size)*self.numButtonsOnScreen))
        self.slider = pygame.draw.rect(self.sliderSurface, Colors.WHITE, self.sliderRect,0,3)
        self.sliderRect.topleft = self.scrollBarRect.topleft



    def listAnimation(self, newPosx, newPosy):
        speed = [newPosx/self.total_animation_frames,newPosy/self.total_animation_frames]
        sliderSpeed = [0,0]
        if newPosy > 0:
            if newPosy > self.buttonList[2].rect.centery - self.buttonList[0].rect.centery:
                sliderSpeed = [0,-((self.scrollBar.height/self.size)/self.total_animation_frames) * (self.size - self.numButtonsOnScreen)]
            else:
                sliderSpeed = [0,-(self.scrollBar.height/self.size)/self.total_animation_frames]
        elif newPosy<0:
            if newPosy < -(self.buttonList[2].rect.centery - self.buttonList[0].rect.centery):
                sliderSpeed = [0,((self.scrollBar.height/self.size)/self.total_animation_frames) * (self.size - self.numButtonsOnScreen)]
            else:
                sliderSpeed = [0,(self.scrollBar.height/self.size)/self.total_animation_frames]

        if self.count < self.total_animation_frames+1:
            # for x in range(len(self.buttonList)):
            for x, button in enumerate(self.buttonList):
                
                self.surface.blit(self.surface,button.rect, button.rect)
                button.rect = button.rect.move(speed)
                self.surface.blit(button.surface, button.rect)
            
                self.surface.blit(self.numSurfaceList[x], self.numRecList[x])
                self.numRecList[x] = self.numRecList[x].move(speed)
                self.surface.blit(self.numSurfaceList[x], self.numRecList[x])

            
            self.surface.blit(self.sliderSurface, self.sliderRect)
            self.sliderRect = self.sliderRect.move(sliderSpeed)
            self.surface.blit(self.sliderSurface, self.sliderRect)
            
            # self.surface.blit(self.cover, (0,499))

        else:
            self.count = 0
            self.isAnimating = False
            self.newPos = [0,0]

    def cursorDown(self) -> None:
        change = self.buttonList[1].rect.centery - self.buttonList[0].rect.centery
        if not self.isAnimating and self.debounce_count >= self.total_debounce_frames:
            self.debounce_count = 0
            if self.cursorPos < self.size-1:
                self.cursorPos += 1
            else:
                self.cursorPos = 0
                change = self.buttonList[len(self.buttonList)-1].rect.centery - self.buttonList[self.numButtonsOnScreen-1].rect.centery
                self.newPos = [0,change]
                self.isAnimating = True
            if not 0 <= self.cursorPos <= self.numButtonsOnScreen-1:
                self.newPos = [0,-change]
                self.isAnimating = True
    
    def cursorUp(self)-> None:
        change = self.buttonList[1].rect.centery - self.buttonList[0].rect.centery
        if not self.isAnimating and self.debounce_count >= self.total_debounce_frames:
            self.debounce_count = 0
            if self.cursorPos > 0:
                self.cursorPos -= 1
                if self.cursorPos >= self.numButtonsOnScreen-1:
                    self.newPos = [0,change]
                    self.isAnimating = True
            else:
                change = self.buttonList[len(self.buttonList)-1].rect.centery - self.buttonList[self.numButtonsOnScreen-1].rect.centery
                self.newPos = [0,-change]
                self.isAnimating = True
                self.cursorPos = len(self.buttonList)-1

    def moveCursor(self, e:pygame.event.Event,controls:Controls):
        if controls.is_button_down(e):
            if controls.is_movement_down(e):
                self.cursorDown()
                
            if controls.is_movement_up(e):
                self.cursorUp()
    
    def render(self):
        
        self.surface.fill(Colors.BLACK)
        self.debounce_count += 1
        if self.isAnimating:
            self.count+=1
            self.listAnimation(self.newPos[0], self.newPos[1])


        # self.surface.blit(self.cursorSurface, (self.buttonList[self.cursorPos].rect.x-51, self.buttonList[self.cursorPos].rect.y-6))        
        self.cursorRect.center = self.buttonList[self.cursorPos].rect.center

        self.surface.blit(self.cursorSurface, self.cursorRect)

        for i,button in enumerate(self.buttonList):
            if button.rect.bottom < self.height:
                self.surface.blit(button.surface, button.rect)
                self.surface.blit(self.numSurfaceList[i], self.numRecList[i])
        
        self.infoSurface.fill(Colors.GRAY)
        drawText(self.infoSurface, self.manifestList[self.cursorPos].name, Colors.WHITE, self.title, self.fontTitle)
        drawText(self.infoSurface, self.manifestList[self.cursorPos].description, Colors.WHITE, self.info, self.font)
        self.surface.blit(self.infoSurface, self.infoSurfaceRect)
        self.surface.blit(self.scrollBarSurface, self.scrollBarRect)

        self.surface.blit(self.sliderSurface, self.sliderRect)

        
        # self.surface.blit(self.cover, (0,0))
        
        self.screen.blit(self.surface,self.surface.get_rect())


    def onSelect(self,callback=None,cargs=()):
        print('List onSelect')
        if callback is not None:
            self.buttonList[self.cursorPos].onSelect(callback,cargs)


#https://www.pygame.org/wiki/TextWrap
# draw some text into an area of a surface
# automatically wraps words
# returns any text that didn't get blitted
def drawText(surface, text, color, rect, font, aa=False, bkg=None):
    rect = Rect(rect)
    y = rect.top
    lineSpacing = 5

    # get the height of the font
    fontHeight = font.size("Tg")[1]

    while text:
        i = 1

        # determine if the row of text will be outside our area
        if y + fontHeight > rect.bottom:
            break

        # determine maximum width of line
        while font.size(text[:i])[0] < rect.width and i < len(text):
            i += 1

        # if we've wrapped the text, then adjust the wrap to the last word      
        if i < len(text): 
            i = text.rfind(" ", 0, i) + 1

        # render the line and blit it to the surface
        if bkg:
            image = font.render(text[:i], 1, color, bkg)
            image.set_colorkey(bkg)
        else:
            image = font.render(text[:i], aa, color)

        surface.blit(image, ((rect.width/2 - image.get_width()/2)+15, y))
        y += fontHeight + lineSpacing

        # remove the text we just blitted
        text = text[i:]

    return text