import pygame
from Constants import *
class SplashImg(pygame.sprite.Sprite):
    def __init__(self, pos_x, pos_y):
        super().__init__()
        
        img1 = pygame.transform.smoothscale(pygame.image.load("./assets/splashscreen/splash1.png").convert(),(SCREEN_WIDTH,SCREEN_HEIGHT))
        img2 = pygame.transform.smoothscale(pygame.image.load("./assets/splashscreen/splash2.png").convert(),(SCREEN_WIDTH,SCREEN_HEIGHT))
        
        # load images
        self.sprites = []
        self.sprites.append(img1)
        self.sprites.append(img2)
        self.current_sprite = 0
        self.image = self.sprites[self.current_sprite]

        # rectangle and position it
        self.rect = self.image.get_rect()
        self.rect.topleft = [pos_x,pos_y]

        self.framecount = 0   
        
    # animate the sprites
    def update(self):
        self.framecount += 1
        
        if self.framecount % 20 != 0:
           return 
        
        self.current_sprite += 1
        
        if self.current_sprite >= len(self.sprites):
            self.current_sprite = 0
        
        self.image = self.sprites[self.current_sprite]