from enum import Enum

class States(Enum):
    """ States the menu can be in
    """
    CAROUSEL = 0
    GRID = 1
    IN_GAME = 3


class MenuStates:

    def __init__(self) -> None:
        self.state = States.CAROUSEL
        self.index = 0

    def get_index(self):
        return self.index

    def set_index(self,newIndex):
        self.index = newIndex

    def next_state(self):
        if(self.is_carousel()):
            self.state = States.GRID
        elif(self.is_grid()):
            self.state = States.CAROUSEL
        elif(self.is_game()):
            print("in game")
        else:
            print("no valid state")

    def is_carousel(self):
        return self.state == States.CAROUSEL

    def is_grid(self):
        return self.state == States.GRID

    def is_game(self):
        return self.state == States.IN_GAME
    
    def go_to_game_state(self):
        self.state = States.IN_GAME

    def go_to_home(self):
        self.state = States.CAROUSEL