import pygame
from pygame.surface import *
import Colors
from Constants import *
from pygame.rect import *

class button():

    def __init__(self,width, height,text, color:tuple[int,int,int]):
        self.screen = Surface((width, height))
        self.color = color
        self.width = width
        self.height = height
        self.text = text
        self.x = 0
        self.y = 0

        self._surface = Surface((self.width,self.height))
        self._rect = pygame.draw.rect(self._surface, color,(self.x,self.y,self.width,self.height))
        self.count = 0
        self.total_animation_frames = 10

        self.font = pygame.font.Font(FONT_FILE_PATH, 14)
        text = self.font.render(self.text, True, Colors.WHITE)
        self._surface.blit(text, ((self.width/2 - text.get_width()/2),(self.height/2 - text.get_height()/2)))


    # def __init__(self, width, height, text):
    #     self.color = (255,0,0)
    #     # self.x = x
    #     # self.y = y
    #     self.width = width
    #     self.height = height
    #     self.text = text
    
    @property
    def surface(self) -> Surface:
        return self._surface
    
    @property
    def rect(self) -> Rect:
        return self._rect
    
    @surface.setter
    def surface(self,s):
        self._surface = s
    
    @rect.setter
    def rect(self,r):
        self._rect = r

    def draw(self, surface, x, y):
        pygame.draw.rect(surface, self.color, (x, y, self.width, self.height))
        
        font = pygame.font.Font(self.font, 20)
        text = font.render(self.text, 1, (0,0,0))
        surface.blit(text, (x + (self.width/2 - text.get_width()/2), y + (self.height/2 - text.get_height()/2)))
    
    def on_hover(self):
        self.color = (0,255,0)
    
    def no_hover(self):
        self.color = (255,0,0)
    
    def onSelect(self,callback=None,cargs=()):
        data = [1,2,3,4]
        print('List Item onSelect')
        if callback is not None:
            callback(cargs,self.text)