import pygame
import time

# Initialize Pygame
pygame.init()

# Set the window size and title
screen_size = (640, 480)
screen = pygame.display.set_mode(screen_size)
pygame.display.set_caption("Frame Rate Test")

# Set the background color
bg_color = (255, 255, 255)

# Set the frame rate (in fps)
frame_rate = 60

# Set the clock to control the frame rate
clock = pygame.time.Clock()

# Set the font for the frame counter
font = pygame.font.Font(None, 36)

# Set the initial frame count
frame_count = 0

# Run the game loop
running = True
while running:
    # Handle events
    for event in pygame.event.get():
        if event.type == pygame.QUIT:
            running = False

    # Clear the screen
    screen.fill(bg_color)

    # Increment the frame count
    frame_count = clock.get_fps()

    # Render the frame count
    text = font.render("Frame Count: {}".format(frame_count), True, (0, 0, 0))
    screen.blit(text, (10, 10))

    # Update the display
    pygame.display.flip()

    # Limit the frame rate
    clock.tick(frame_rate)

# Quit Pygame
pygame.quit()