import signal
import sys
import pygame
from typing import List
from context import FPSCounter

pygame.init()

WIDTH = 640
HEIGHT = 480

size = width, height = WIDTH, HEIGHT

mainClock = pygame.time.Clock()
flags=pygame.SCALED
screen = pygame.display.set_mode(size,flags, vsync=1 )


surfList: List[pygame.surface.Surface] = []
rectList: List[pygame.rect.Rect] = []

background = pygame.Surface((WIDTH,HEIGHT))
background.fill((0,0,0))

containerSurface = pygame.Surface((WIDTH,HEIGHT))
squareSize = 100
for i in range(0,10):
    surface = pygame.Surface((squareSize,squareSize))
    # surface.fill((255,255,255))
    # rect = surface.get_rect()
    rect = pygame.draw.rect(surface,(255,255,255),(0,0,squareSize,squareSize))
    # rect.centerx = screen.get_rect().centerx
    # if (i == 0):
    #     rect.top = 10
    # else:
    #     rect.top = rectList[i-1].bottom + 20
    rect.centery = screen.get_rect().centery
    if (i == 0):
        rect.left = 10
    else:
        rect.left = rectList[i-1].right + 100
    
    surfList.append(surface)
    rectList.append(rect)
    containerSurface.blit(surface,rect)

def animate(speed):
    # speed = [10000/60,0]    
    
    for x,surf in enumerate(surfList):
        # print(x,surf,surf.get_rect(),rect)
        screen.blit(background,rectList[x],rectList[x])
        # rectList[x] = rectList[x].move(-1,0)
        # rectList[x].y += speed
        # if (x>= - 500 and x<= (width+500) ):
        rectList[x].x += speed
        # print(x,rectList[x])
        # print(rect)
        screen.blit(surf,rectList[x])
    
    # containerSurface.fill((0,0,0))
    # containerSurface.scroll(speed,0)    
            
        
def render():
    containerSurface.fill((0,0,0))
    for x,item in enumerate(rectList):
        # print(x,item)
        # screen.blit(background,item,item)
        # item = item.move(speed)
        # containerSurface.blit(background,item,item)
        containerSurface.blit(surfList[x],item)
    screen.blit(containerSurface,(0,0))
    
def eventLoop():
    fpsCounter = FPSCounter.FPSCounter(screen,mainClock)
    counter = 0
    while True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
                raise SystemExit
        
        screen.blit(background,(0,0))
        

        # animate([0,0])
        keys = pygame.key.get_pressed()
        speed = 10
        if (keys[pygame.K_LEFT]):
            animate(-speed)
        if(keys[pygame.K_RIGHT]):
            animate(speed)
        # # print('I am runnig')
        render()
        # animate([-1,0])
        counter+=1
        counter%=60
        print(counter,fpsCounter.framecount, mainClock.get_rawtime())
        fpsCounter.render()
        pygame.display.flip()
        mainClock.tick(55)


def exit_handler(sig, frame):
    pygame.quit()
    sys.exit()                

if __name__ == '__main__':
    signal.signal(signal.SIGINT, exit_handler)
    # menu.mainloop(surface)
    pygame.event.clear()
    # pygame.display.toggle_fullscreen()
    eventLoop()
